---
layout: handbook-page-toc
title: "GitLab with Git Basics Hands On Guide- Lab 2"
description: "This Hands On Guide Lab is designed to walk you through the lab exercises used in the GitLab with Git Basics course."
---
# GitLab with Git Basics Hands On Guide- Lab 2
{:.no_toc}

## LAB 2- WORKING WITH GIT LOCALLY

**Prior to starting this lab, verify git is installed locally:** 

● Open a terminal session or command prompt and type “***git version***” and press **Enter** 

### Generate an SSH Key
These steps are only needed if you do not have an SSH key already installed.
1. Open a terminal or command prompt window and enter the following command:  “***ssh-keygen”*** 
2. You will be prompted to select the location in which your key will be saved, press the **Enter** key to leave it at the default. 
3. You may be prompted to create a passphrase, enter a password of your choice and hit the **Enter** key. 

### Add an SSH Key to GitLab Profile
1. On the right-hand side of the screen, locate your user avatar and click on the **down arrow**.  
2. From the drop-down menu, click on the **Edit Profile** item.
3. On the left-hand side of the screen, click on **SSH Keys**. 
4. If you have no SSH keys added to your profile, you will land on the Add an SSH Key screen.  
5. Navigate back to your terminal/command session, in order to retrieve the SSH key you created, we need to move into the folder we saved them to.  
6. In the terminal/command window, type “***cd {file path}***” and press **Enter**. 
7. In the terminal/command window, type “***ls -al***” and press **Enter**.  
*Note the two files, they represent a public and private key, the public key (id\_rsa.pub) is what is needed to share with GitLab* 
8. In the terminal/command window, type “***cat id\_rsa.pub”*** and press **Enter** and copy the entire contents of your public key. 
9. Navigate back to the GitLab Platform and paste the key into the open text field and click the **Add Key** button.  
10. Your local computer is now authenticated to push and pull (interact) with GitLab

### Copy (Clone) Project Repo to Your Local Machine 
1. Navigate back to your **Project Overview**  
2. Locate the blue **Clone** button and click the drop down arrow.  
3. In the Clone with SSH section, click the **Copy URL** button.  

### Create a Directory on Your Local Machine
1. In your terminal/command window, type “[***cd***](https://about.gitlab.com/images/press/git-cheat-sheet.pdf)” to get out of the .ssh directory into your home directory. 
2. In your terminal/command window, type “***mkdir training***” and press **Enter** to create a new directory. 
3. In your terminal/command window, type “***cd training***” and press **Enter** to move into your new directory. 
4. Next, type “***git clone <URL you copied previously>***” and press **Enter**.  
5. Now move into that directory you just cloned by typing “***cd top-level-project-repo***” and press **Enter**.  
This is where the git software will track your changes, and where you will interact with the repo and git. 
6. In your terminal/command window, type “***ls -al***” and press **Enter** to receive a list of all files in your current directory, including hidden files.
7. On your terminal/command window type “***git status”*** and press **enter**. You will receive a message saying your working tree is clean.  

### Work on a Branch
1. In your terminal/command window, type “***git checkout -b temporary\_branch”*** and press **Enter**.  
2. In your terminal/command window, type “***git branch -a”***  and press **Enter** to see all branches. 

*Note the red branches are on the remote server (GitLab)* 

### Make a Change to a README File
1. Navigate to your README.md file.  
2. Using the editor of your choice type, “***a second line added to master branch locally.***” below the line current line and save the file. 
3. Type “***git status”*** and press **Enter**. 

Note:  GitLab has detected we have added a file to our local repo.  Your branch is up to date with origin/master: We have not authored our first commit yet, and therefore; not created a new snapshot yet. 

### Stage the README file to the GitLab staging area locally
1. In your terminal/command window, type “***git add README.md”*** and press **Enter**. If this was successful, the command window will move to a new line with no error message. 
Note: We have taken our README.md file from our working directory, and moved it to a “staging area”  
2. Type “***git status”*** and press **Enter**. 

### Commit the changes to the README.md file
1. In your terminal/command window, type “***git commit -m “added a second line to readme.md file””*** and press **Enter**. 
- **Developer Tip:** You can stage and commit a change at the same time by using the “git commit -am “commit message” command to save time! 
2. We have now created a record or point in time snapshot of the file that we can refer back to if needed. 
3. In your terminal/command window, type “***git status”*** and review the changes. 

### Push your changes to the temporary branch on the remote GitLab server
1. In your terminal/command window, type “***git push -u origin temporary\_branch”*** and press **Enter**. Enter the passcode for your SSH key if prompted. 
- **Developer Tip:** If you are ever unsure of the exact command you need to push your changes to the remote server, type “git push” and press **Enter**. The system will output an error message with the correct commands you can copy/paste.  

###Modify Your Content Again
1. In your code editor, navigate to the README.md file  and edit the contents to include, “add a third line to file” 2 lines below the last change and save your changes in the editor.  
Note: We typically use [Visual Studio Code](https://code.visualstudio.com/sha/download?build=stable&os=darwin-universal). 
3. In your terminal/command window, type “***git add README.md”*** and press **Enter**.  
4. In your terminal/command window, type “***git commit -m “modified the readme.md file””*** and press **Enter**. 
5. In your terminal/command window, type “***git log”*** and press **Enter**. 
6. In your terminal/command window, type “***git push”*** and press **Enter**. 
- **Developer Tip:** If you want to commit your changes to your upstream, you can simply use the command type “git push -u” and press **Enter**. The system only needs to set the upstream once.  
7. Navigate to the remote GitLab.com platform and view changes to your project. 

### Simulate a change on the branch 
Someone in your organization has merged a feature branch into master.  The code has moved code under our feet (so to speak) and now your local directory is out of sync with the remote. We now must update the state of the master branch. 

1. From the GitLab dashboard, navigate to your Top Level Project and click on the Temporary Branch from the drop down on the repository screen. 
2. On your temporary\_branch, click on the **README.md** file. 
3. Click on the **Web IDE** button. 
4. In the editor, on line 9 type, “***add a fourth line from the remote on the temporary\_branch***”
5. Click the **Commit** button.  
6. Uncheck both boxes for **Create a New Branch** and **Start a New Merge Request.** 
Note:  you are working on the server now, the server is one commit ahead from your local repository. 
7. Click the **Commit** button to finalize the changes.  

### Refresh the state of your local branch using the fetch command
The git fetch command retrieves the updated state of branches without updating the contents.  
1. Return to your terminal/command window and type “***git fetch”*** and press **Enter.** If you are prompted for your SSH passphrase, enter it. 
2. Type “***git status”*** and press **Enter.** Review the updated status of your local branch. 

### Pull from the remote repository (upstream)
We now need to explicitly tell git to update the contents. 
1. In your terminal/command window, type “***git pull*** and press **Enter.**
2. To view the contents of the README.md file, type “***cat README.md”*** and press **Enter.**

### Merge all changes from the temporary\_branch into the Master branch 
1. In your terminal/command window, type “***git branch*** to verify which branch you are currently working in. You should already be in the temporary branch.
2. Switch to your Master Branch, in your terminal/command window, type “***git checkout master***  and press **Enter**.  
3. From the master branch, type “***git merge temporary\_branch”*** and press **Enter**.  

### Update the remote repository
1. In your terminal/command window, type “***git status*** and press **Enter**.  
2. Type “***git push*** and press **Enter.**
3. Navigate back to GitLab.com and view your Project Master Branch and view the changes made.

### SUGGESTIONS?

If you wish to make a change to our Hands on Guide for GitLab with Git Basics- please submit your changes via Merge Request!
